/* tslint:disable */
/* eslint-disable */
/**
 * opGUI - OpenAPI 3.0
 * Dummy description about the available endpoints Some useful links: - [The opGUI repository](https://gitlab.eclipse.org/eclipse/openpass/opgui) - [The documentation page](https://www.eclipse.org/openpass/content/html/index.html)
 *
 * The version of the OpenAPI document: 1.1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import * as runtime from '../runtime';
import type {
  Error400,
  Error500,
  FileTreeExtended,
  FileTreeRequest,
} from '../models';
import {
    Error400FromJSON,
    Error400ToJSON,
    Error500FromJSON,
    Error500ToJSON,
    FileTreeExtendedFromJSON,
    FileTreeExtendedToJSON,
    FileTreeRequestFromJSON,
    FileTreeRequestToJSON,
} from '../models';

export interface ApiGetFileTreePostRequest {
    fileTreeRequest: FileTreeRequest;
}

/**
 * 
 */
export class GetFileTreeApi extends runtime.BaseAPI {

    /**
     * Endpoint to retrieve the file tree based on the provided parameters.
     * Endpoint to retrieve the file tree based on the provided parameters.
     */
    async apiGetFileTreePostRaw(requestParameters: ApiGetFileTreePostRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<runtime.ApiResponse<FileTreeExtended>> {
        if (requestParameters.fileTreeRequest === null || requestParameters.fileTreeRequest === undefined) {
            throw new runtime.RequiredError('fileTreeRequest','Required parameter requestParameters.fileTreeRequest was null or undefined when calling apiGetFileTreePost.');
        }

        const queryParameters: any = {};

        const headerParameters: runtime.HTTPHeaders = {};

        headerParameters['Content-Type'] = 'application/json';

        const response = await this.request({
            path: `/api/getFileTree`,
            method: 'POST',
            headers: headerParameters,
            query: queryParameters,
            body: FileTreeRequestToJSON(requestParameters.fileTreeRequest),
        }, initOverrides);

        return new runtime.JSONApiResponse(response, (jsonValue) => FileTreeExtendedFromJSON(jsonValue));
    }

    /**
     * Endpoint to retrieve the file tree based on the provided parameters.
     * Endpoint to retrieve the file tree based on the provided parameters.
     */
    async apiGetFileTreePost(requestParameters: ApiGetFileTreePostRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<FileTreeExtended> {
        const response = await this.apiGetFileTreePostRaw(requestParameters, initOverrides);
        return await response.value();
    }

}
